"use strict";
/**
 * Defines a `Decoder`, namely a function that receives an `unknown` value and tries to decodes it in an `A` value.
 *
 * It returns an `Either` with a `string` as `Left` when decoding fails or an `A` as `Right` when decoding succeeds.
 *
 * @since 0.5.0
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var E = __importStar(require("fp-ts/lib/Either"));
var RE = __importStar(require("fp-ts/lib/ReaderEither"));
var pipeable_1 = require("fp-ts/lib/pipeable");
/**
 * @category instances
 * @since 0.5.0
 */
exports.URI = 'elm-ts/Decoder';
/**
 * @category constructors
 * @since 0.5.0
 */
exports.left = RE.left;
/**
 * @category constructors
 * @since 0.5.0
 */
exports.right = RE.readerEither.of;
/**
 * @category combinators
 * @since 0.5.0
 */
exports.orElse = RE.orElse;
/**
 * @category instances
 * @since 0.5.0
 */
exports.decoder = {
    URI: exports.URI,
    map: RE.readerEither.map,
    of: exports.right,
    ap: RE.readerEither.ap,
    chain: RE.readerEither.chain,
    alt: RE.readerEither.alt,
    zero: function () { return function () { return E.left('zero'); }; }
};
var _a = pipeable_1.pipeable(exports.decoder), alt = _a.alt, ap = _a.ap, apFirst = _a.apFirst, apSecond = _a.apSecond, chain = _a.chain, chainFirst = _a.chainFirst, flatten = _a.flatten, map = _a.map;
exports.alt = alt;
exports.ap = ap;
exports.apFirst = apFirst;
exports.apSecond = apSecond;
exports.chain = chain;
exports.chainFirst = chainFirst;
exports.flatten = flatten;
exports.map = map;
