"use strict";
/**
 * A specialization of `Html` that uses `React` as renderer.
 *
 * @since 0.5.0
 */
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var html = __importStar(require("./Html"));
/**
 * `map()` is `Html.map()` with `Html` type constrained to the specialized version for `React`.
 * @category Functor
 * @since 0.5.0
 */
function map(f) {
    return html.map(f);
}
exports.map = map;
/**
 * `program()` is `Html.program()` with `Html` type constrained to the specialized version for `React`.
 * @category constructors
 * @since 0.5.0
 */
function program(init, update, view, subscriptions) {
    return html.program(init, update, view, subscriptions);
}
exports.program = program;
/**
 * Same as `program()` but with `Flags` that can be passed when the `Program` is created in order to manage initial values.
 * @category constructors
 * @since 0.5.0
 */
function programWithFlags(init, update, view, subscriptions) {
    return function (flags) { return program(init(flags), update, view, subscriptions); };
}
exports.programWithFlags = programWithFlags;
/**
 * `run()` is `Html.run()` with `dom` type constrained to the specialized version for `React`.
 * @category utils
 * @since 0.5.0
 */
function run(program, renderer) {
    return html.run(program, renderer);
}
exports.run = run;
